package com.demoad.plugin_codelab.adhelper.ads;

import android.app.Activity;
import android.text.TextUtils;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Display;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;

import androidx.annotation.NonNull;

import com.demoad.plugin_codelab.R;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsAvailability;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsPreferenceClass;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsUtils;
import com.google.android.gms.ads.AdListener;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.AdSize;
import com.google.android.gms.ads.AdView;
import com.google.android.gms.ads.LoadAdError;
import com.google.android.gms.ads.admanager.AdManagerAdView;

import java.util.ArrayList;
import java.util.List;

public class Pack5Banner {

    /* Banner */
    /* Banner */
    /* Banner */
    public static void showBannerAdsMain(ViewGroup adContainerView, Activity activity) {

        Pack5AdsAvailability.isBannerAvailability(activity, new Pack5AdsAvailability.onReturnAdsTypeListner() {
            @Override
            public void onAdMobAdAvailability() {
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Admob Banner Enable ====>");
                loadAdMobBanner(adContainerView, activity);
            }

            @Override
            public void onAdxAdAvailability() {
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Adx Banner Enable ====>");
                loadAdxBanner(adContainerView, activity);
            }

            @Override
            public void onFbAdAvailability() {
                Log.e("TAG", "onFbAdAvailability: dgfbf ");
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "<==== FB Banner Enable ====>");
                loadFbBanner(adContainerView, activity);
            }

            @Override
            public void onEmpty() {
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "<==== All Banner Disable ====>");

                adContainerView.setVisibility(View.GONE);
            }
        });


    }

    private static void loadAdMobBanner(ViewGroup adContainerView, Activity activity) {
        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getAdmobBannerId();

        Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "Admob Banner ID ==> " + adUnitId);

        if (TextUtils.isEmpty(adUnitId)) {
            loadAdxBanner(adContainerView, activity);
            return;
        }

        //BannerAd
        AdView admobManagerAdView = new AdView(activity);
        admobManagerAdView.setAdUnitId(adUnitId);
        adContainerView.addView(admobManagerAdView);
        AdRequest adRequest = new AdRequest.Builder().build();
        AdSize adSize = getAdSize(activity);
        admobManagerAdView.setAdSize(AdSize.BANNER);
        admobManagerAdView.loadAd(adRequest);
        admobManagerAdView.setAdListener(new AdListener() {
            @Override
            public void onAdLoaded() {
                super.onAdLoaded();

                adContainerView.setVisibility(View.VISIBLE);
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "Admob BannerAd ==> onAdLoaded");
            }

            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError loadAdError) {
                super.onAdFailedToLoad(loadAdError);
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "Admob BannerAd ==> onAdFailedToLoad \n" + loadAdError.getMessage());
                loadAdxBanner(adContainerView, activity);
            }
        });
    }

    private static void loadAdxBanner(ViewGroup adContainerView, Activity activity) {
        String adUnitId;

        adUnitId = Pack5AdsPreferenceClass.getAdxBannerId();

        Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "Adx BannerAd ID ==> " + adUnitId);

        if (TextUtils.isEmpty(adUnitId)) {
            loadFbBanner(adContainerView, activity);
            return;
        }

        AdManagerAdView adXManagerAdView = new AdManagerAdView(activity);
        adXManagerAdView.setAdUnitId(adUnitId);
        adContainerView.addView(adXManagerAdView);
        AdRequest adRequest = new AdRequest.Builder().build();
        AdSize adSize = getAdSize(activity);
        adXManagerAdView.setAdSize(AdSize.BANNER);
        adXManagerAdView.loadAd(adRequest);
        adXManagerAdView.setAdListener(new AdListener() {
            @Override
            public void onAdLoaded() {
                super.onAdLoaded();

                adContainerView.setVisibility(View.VISIBLE);
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "Adx BannerAd ==> onAdLoaded");
            }

            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError loadAdError) {
                super.onAdFailedToLoad(loadAdError);
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "Adx BannerAd ==> onAdFailedToLoad \n" + loadAdError.getMessage());
                loadFbBanner(adContainerView, activity);
            }
        });
    }

    private static AdSize getAdSize(Activity activity) {
        Display display = activity.getWindowManager().getDefaultDisplay();
        DisplayMetrics outMetrics = new DisplayMetrics();
        display.getMetrics(outMetrics);
        float widthPixels = outMetrics.widthPixels;
        float density = outMetrics.density;
        int adWidth = (int) (widthPixels / density);
        return AdSize.getCurrentOrientationAnchoredAdaptiveBannerAdSize(activity, adWidth);
    }

    private static void loadFbBanner(ViewGroup adContainerView, Activity activity) {
        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getFbBannerId();

        Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "FB BannerAd ID ==> " + adUnitId);
        Log.e("TAG", "onFbAdAvailability: dgfbf " + "FB BannerAd ID ==> " + adUnitId);
        com.facebook.ads.AdView adView = new com.facebook.ads.AdView(activity, adUnitId, com.facebook.ads.AdSize.BANNER_HEIGHT_50);
        adContainerView.addView(adView);
        com.facebook.ads.AdListener adListener = new com.facebook.ads.AdListener() {
            @Override
            public void onError(com.facebook.ads.Ad ad, com.facebook.ads.AdError adError) {

                adContainerView.setVisibility(View.GONE);
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "FB BannerAd ==> onError \n" + adError.getErrorMessage());
                Log.e("TAG", "onFbAdAvailability: dgfbf " + "FB BannerAd ==> onError \n" + adError.getErrorMessage());
            }

            @Override
            public void onAdLoaded(com.facebook.ads.Ad ad) {

                adContainerView.setVisibility(View.VISIBLE);
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB BannerAd ==> onAdLoaded");
            }

            @Override
            public void onAdClicked(com.facebook.ads.Ad ad) {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB BannerAd ==> onAdClicked");
            }

            @Override
            public void onLoggingImpression(com.facebook.ads.Ad ad) {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB BannerAd ==> onLogggingImoression");
            }
        };
        com.facebook.ads.AdView.AdViewLoadConfig loadAdConfig = adView.buildLoadAdConfig().withAdListener(adListener).build();
        adView.loadAd(loadAdConfig);
    }


}
