package com.demoad.plugin_codelab.adhelper.ads;

import static com.demoad.plugin_codelab.ASDK.BaseApp.currentActivity;
import static com.demoad.plugin_codelab.adhelper.ads.Pack5NativeSmallUp.addTitleColor;

import android.app.Activity;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RatingBar;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.appcompat.widget.AppCompatButton;

import com.demoad.plugin_codelab.R;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsAvailability;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsPreferenceClass;
import com.facebook.ads.AdOptionsView;
import com.facebook.ads.NativeAdListener;
import com.google.android.gms.ads.AdListener;
import com.google.android.gms.ads.AdLoader;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.LoadAdError;
import com.google.android.gms.ads.VideoController;
import com.google.android.gms.ads.VideoOptions;
import com.google.android.gms.ads.admanager.AdManagerAdRequest;
import com.google.android.gms.ads.nativead.MediaView;
import com.google.android.gms.ads.nativead.NativeAd;
import com.google.android.gms.ads.nativead.NativeAdOptions;
import com.google.android.gms.ads.nativead.NativeAdView;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class Pack5NativeRegular {
    public static NativeAd mPack5NativeAdsRegular = null;

    /*//
    // Big
    //*/

    public static void showNativeAdsBigMain(ViewGroup fl_adplaceholder, Activity activity) {

       
        Pack5AdsAvailability.isNativeAvailability(activity, new Pack5AdsAvailability.onReturnAdsTypeListner() {
            @Override
            public void onAdMobAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Admob Native Big Enable ====>");
                if (mPack5NativeAdsRegular != null) {
                    mPack5NativeAdsRegular.destroy();
                    mPack5NativeAdsRegular = null;
                }
                loadAdmobNativeAdBig(fl_adplaceholder, activity);
            }

            @Override
            public void onAdxAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Adx Native Big Enable ====>");
                if (mPack5NativeAdsRegular != null) {
                    mPack5NativeAdsRegular.destroy();
                    mPack5NativeAdsRegular = null;
                }
                loadAdxNativeAdBig(fl_adplaceholder, activity);
            }

            @Override
            public void onFbAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== FB Native Big Enable ====>");
                loadFbNativeAdBig(fl_adplaceholder, activity);
            }

            @Override
            public void onEmpty() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== All Native Big Disable ====>");
                fl_adplaceholder.setVisibility(View.GONE);

            }
        });


    }
    public static void showNativeAdsBigMainShimmer(FrameLayout fl_adplaceholder, Activity activity) {

        Pack5AdsAvailability.isNativeAvailability(activity, new Pack5AdsAvailability.onReturnAdsTypeListner() {
            @Override
            public void onAdMobAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Admob Native Big Enable ====>");
                if (mPack5NativeAdsRegular != null) {
                    mPack5NativeAdsRegular.destroy();
                    mPack5NativeAdsRegular = null;
                }
                loadAdmobNativeAdBig(fl_adplaceholder, activity);
            }

            @Override
            public void onAdxAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Adx Native Big Enable ====>");
                if (mPack5NativeAdsRegular != null) {
                    mPack5NativeAdsRegular.destroy();
                    mPack5NativeAdsRegular = null;
                }
                loadAdxNativeAdBig(fl_adplaceholder, activity);
            }

            @Override
            public void onFbAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== FB Native Big Enable ====>");
                loadFbNativeAdBig(fl_adplaceholder, activity);
            }

            @Override
            public void onEmpty() {
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== All Native Big Disable ====>");
                fl_adplaceholder.setVisibility(View.GONE);

            }
        });


    }

    /*load native*/
    //admob
    public static void loadAdmobNativeAdBig(ViewGroup fl_adplaceholder , Activity activity) {

        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getAdmobNativeId();
        Log.e("TAG", "loadAdmobNativeAdBig: adunit id == "+adUnitId );

        if (TextUtils.isEmpty(adUnitId)) {
            loadAdxNativeAdBig(fl_adplaceholder, activity);
            return;
        }
       Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob NativeAds Big ID ==> " + adUnitId);

        AdLoader.Builder builder = new AdLoader.Builder(activity, adUnitId);

        builder.forNativeAd(nativeAd -> {
            mPack5NativeAdsRegular = nativeAd;
            showNativeOptionAdBig(fl_adplaceholder, activity);

        }).withAdListener(new AdListener() {

            @Override
            public void onAdLoaded() {
                super.onAdLoaded();
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob NativeAds Big ==> " + "onAdLoaded");
            }

            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError loadAdError) {
                super.onAdFailedToLoad(loadAdError);
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob NativeAds Big => onAdFailedToLoad  ====\n" + loadAdError.getMessage());
            }
        });

        VideoOptions videoOptions = new VideoOptions.Builder().setStartMuted(true).build();

        NativeAdOptions adOptions = new NativeAdOptions.Builder().setVideoOptions(videoOptions).build();

        builder.withNativeAdOptions(adOptions);
        AdLoader adLoader = builder.withAdListener(new AdListener() {
            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError adError) {
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob NativeAds Big => onAdFailedToLoad  111== \n" + adError.getMessage());
                loadAdxNativeAdBig(fl_adplaceholder, activity);
            }
        }).build();

        adLoader.loadAd(new AdRequest.Builder().build());

    }

    /*load native*/
    //adx
    public static void loadAdxNativeAdBig(ViewGroup fl_adplaceholder , Activity activity) {

        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getAdxNativeId();

        if (TextUtils.isEmpty(adUnitId)) {
            loadFbNativeAdBig(fl_adplaceholder, activity);
            return;
        }
       Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx NativeAds Big ID ==> " + "onAdLoaded");
        AdLoader.Builder builder = new AdLoader.Builder(activity, adUnitId);

        builder.forNativeAd(nativeAd -> {
            mPack5NativeAdsRegular = nativeAd;
            showNativeOptionAdBig(fl_adplaceholder, activity);

        }).withAdListener(new AdListener() {

            @Override
            public void onAdLoaded() {
                super.onAdLoaded();
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx NativeAds Big ==> " + "onAdLoaded");
            }

            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError loadAdError) {
                super.onAdFailedToLoad(loadAdError);
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx NativeAds Big => onAdFailedToLoad \n" + loadAdError.getMessage());
            }
        });

        VideoOptions videoOptions = new VideoOptions.Builder().setStartMuted(true).build();

        NativeAdOptions adOptions = new NativeAdOptions.Builder().setVideoOptions(videoOptions).build();

        builder.withNativeAdOptions(adOptions);
        AdLoader adLoader = builder.withAdListener(new AdListener() {
            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError adError) {
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx NativeAds Big => onAdFailedToLoad \n" + adError.getMessage());
                loadFbNativeAdBig(fl_adplaceholder, activity);
            }
        }).build();

        adLoader.loadAd(new AdManagerAdRequest.Builder().build());

    }

    /*load native*/
    //adx
    private static void loadFbNativeAdBig(ViewGroup fl_adplaceholder , Activity activity) {
        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getFbNativeId();
       Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB Native Ads Big ID ==> " + adUnitId);

        com.facebook.ads.NativeAd nativeAd = new com.facebook.ads.NativeAd(activity, adUnitId);
        NativeAdListener nativeAdListener = new NativeAdListener() {
            @Override
            public void onMediaDownloaded(com.facebook.ads.Ad ad) {
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB Native Ads Big ==> onMediaDownloaded");
            }

            @Override
            public void onError(com.facebook.ads.Ad ad, com.facebook.ads.AdError adError) {
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB Native Ads Big onAdFailedToLoad ==> \n" + adError.getErrorMessage());

            }

            @Override
            public void onAdLoaded(com.facebook.ads.Ad ad) {
                if (nativeAd != ad) {
                    return;
                }

               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB Native Ads Big ==> onAdLoaded");
                populatFbNativeAd(fl_adplaceholder, activity, nativeAd);
            }

            @Override
            public void onAdClicked(com.facebook.ads.Ad ad) {
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB Native Ads Big ==> onAdClicked");
            }

            @Override
            public void onLoggingImpression(com.facebook.ads.Ad ad) {
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB Native Ads Big ==> onLoggingImpression");
            }
        };
        nativeAd.loadAd(nativeAd.buildLoadAdConfig().withAdListener(nativeAdListener).build());
    }

    /*show native*/
    public static void showNativeOptionAdBig(ViewGroup fl_adplaceholder, Activity activity) {
        try {
            if (mPack5NativeAdsRegular != null) {
                NativeAdView adView = (NativeAdView) LayoutInflater.from(activity).inflate(R.layout.ad_unifiled_regular, null);
                populateUnifiedNativeRegularAdView(mPack5NativeAdsRegular, adView,fl_adplaceholder);
                fl_adplaceholder.setVisibility(View.VISIBLE);
                fl_adplaceholder.removeAllViews();
                fl_adplaceholder.addView(adView);
               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Native Ads Big ==> Success to show");
            } else {
                fl_adplaceholder.setVisibility(View.GONE);

               Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Native Ads Big ==> null");
            }
        } catch (Exception e) {
            e.printStackTrace();
            fl_adplaceholder.setVisibility(View.GONE);

           Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Native Ads Big ==> Exception \n" + e.getMessage());

        }
    }

    /*populat native*/
    public static void populateUnifiedNativeRegularAdView(NativeAd nativeAd, NativeAdView adView,ViewGroup fl_adplaceholder) {
        MediaView mediaView = adView.findViewById(R.id.ad_media);
        adView.setMediaView(mediaView);

        adView.setHeadlineView(adView.findViewById(R.id.ad_headline));
        adView.setBodyView(adView.findViewById(R.id.ad_body));
        adView.setCallToActionView(adView.findViewById(R.id.ad_call_to_action));
        adView.setIconView(adView.findViewById(R.id.ad_app_icon));
        adView.setPriceView(adView.findViewById(R.id.ad_price));
        adView.setStarRatingView(adView.findViewById(R.id.ad_stars));
        adView.setStoreView(adView.findViewById(R.id.ad_store));
        adView.setAdvertiserView(adView.findViewById(R.id.ad_advertiser));

        try {
            ((TextView) Objects.requireNonNull(adView.getHeadlineView())).setText(nativeAd.getHeadline());
        } catch (Exception e) {
            e.printStackTrace();
        }

        if (nativeAd.getBody() == null) {
            Objects.requireNonNull(adView.getBodyView()).setVisibility(View.INVISIBLE);
        } else {
            Objects.requireNonNull(adView.getBodyView()).setVisibility(View.VISIBLE);
            ((TextView) adView.getBodyView()).setText(nativeAd.getBody());
        }

        if (nativeAd.getCallToAction() == null) {
            Objects.requireNonNull(adView.getCallToActionView()).setVisibility(View.INVISIBLE);
        } else {
            Objects.requireNonNull(adView.getCallToActionView()).setVisibility(View.VISIBLE);
            ((TextView) adView.getCallToActionView()).setText(nativeAd.getCallToAction());
        }

        if (nativeAd.getIcon() == null) {
            Objects.requireNonNull(adView.getIconView()).setVisibility(View.GONE);
        } else {
            ((ImageView) Objects.requireNonNull(adView.getIconView())).setImageDrawable(nativeAd.getIcon().getDrawable());
            adView.getIconView().setVisibility(View.VISIBLE);
        }

        if (nativeAd.getPrice() == null) {
            adView.getPriceView().setVisibility(View.INVISIBLE);
        } else {
            adView.getPriceView().setVisibility(View.VISIBLE);
            ((TextView) adView.getPriceView()).setText(nativeAd.getPrice());
        }
        if (nativeAd.getStore() == null) {
            adView.getStoreView().setVisibility(View.INVISIBLE);
        } else {
            adView.getStoreView().setVisibility(View.VISIBLE);
            ((TextView) adView.getStoreView()).setText(nativeAd.getStore());
        }

        if (nativeAd.getStarRating() == null) {
            adView.getStarRatingView().setVisibility(View.INVISIBLE);
        } else {
            ((RatingBar) Objects.requireNonNull(adView.getStarRatingView())).setRating(nativeAd.getStarRating().floatValue());
            adView.getStarRatingView().setVisibility(View.VISIBLE);
        }

        if (nativeAd.getAdvertiser() == null) {
            Objects.requireNonNull(adView.getAdvertiserView()).setVisibility(View.INVISIBLE);
        } else {
            ((TextView) Objects.requireNonNull(adView.getAdvertiserView())).setText(nativeAd.getAdvertiser());
            adView.getAdvertiserView().setVisibility(View.VISIBLE);
        }

        adView.getStoreView().setVisibility(View.GONE);
        adView.getPriceView().setVisibility(View.GONE);
        try{
            addTitleColor(currentActivity,fl_adplaceholder,adView,nativeAd);
        }catch (Exception e) {
            e.printStackTrace();
        }
        adView.setNativeAd(nativeAd);

        VideoController vc = Objects.requireNonNull(nativeAd.getMediaContent()).getVideoController();

        if (vc.hasVideoContent()) {
            vc.setVideoLifecycleCallbacks(new VideoController.VideoLifecycleCallbacks() {
                @Override
                public void onVideoEnd() {
                    super.onVideoEnd();
                }
            });
        }

    }

    /*populat native*/
//    Native
    private static void populatFbNativeAd(ViewGroup fl_adplaceholder, Activity activity, com.facebook.ads.NativeAd nativeAd) {
        nativeAd.unregisterView();

        LayoutInflater inflater = LayoutInflater.from(activity);
        View adView = inflater.inflate(R.layout.ad_item_native_fb, fl_adplaceholder, false);
        fl_adplaceholder.addView(adView);

        LinearLayout adChoicesContainer = adView.findViewById(R.id.ad_choices_container);
        AdOptionsView adOptionsView = new AdOptionsView(activity, nativeAd, activity.findViewById(R.id.flNativeFbBig));
        adChoicesContainer.removeAllViews();
        adChoicesContainer.addView(adOptionsView, 0);

        com.facebook.ads.MediaView nativeAdIcon = adView.findViewById(R.id.native_ad_icon);
        TextView nativeAdTitle = adView.findViewById(R.id.native_ad_title);
        com.facebook.ads.MediaView nativeAdMedia = adView.findViewById(R.id.native_ad_media);
        TextView nativeAdSocialContext = adView.findViewById(R.id.native_ad_social_context);
        TextView nativeAdBody = adView.findViewById(R.id.native_ad_body);
        TextView sponsoredLabel = adView.findViewById(R.id.native_ad_sponsored_label);
        AppCompatButton nativeAdCallToAction = adView.findViewById(R.id.native_ad_call_to_action);

        nativeAdTitle.setText(nativeAd.getAdvertiserName());
        nativeAdBody.setText(nativeAd.getAdBodyText());
        nativeAdSocialContext.setText(nativeAd.getAdSocialContext());
        nativeAdCallToAction.setVisibility(nativeAd.hasCallToAction() ? View.VISIBLE : View.INVISIBLE);
        nativeAdCallToAction.setText(nativeAd.getAdCallToAction());
        sponsoredLabel.setText(nativeAd.getSponsoredTranslation());

        List<View> clickableViews = new ArrayList<>();
        clickableViews.add(nativeAdMedia);
        clickableViews.add(nativeAdTitle);
            clickableViews.add(sponsoredLabel);
            clickableViews.add(nativeAdSocialContext);
        clickableViews.add(nativeAdBody);
        clickableViews.add(nativeAdCallToAction);
        clickableViews.add(nativeAdIcon);

        nativeAd.registerViewForInteraction(adView, nativeAdMedia, nativeAdIcon, clickableViews);
    }


}
