import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'plugin_codelab_method_channel.dart';

abstract class PluginCodelabPlatform extends PlatformInterface {
  /// Constructs a PluginCodelabPlatform.
  PluginCodelabPlatform() : super(token: _token);

  static final Object _token = Object();

  static PluginCodelabPlatform _instance = MethodChannelPluginCodelab();

  /// The default instance of [PluginCodelabPlatform] to use.
  ///
  /// Defaults to [MethodChannelPluginCodelab].
  static PluginCodelabPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [PluginCodelabPlatform] when
  /// they register themselves.
  static set instance(PluginCodelabPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future getCallInterstitialAds() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future getCallCloseInterstitialAds() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future adsONorOFf() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future onesignalKey() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future isCustomeads() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future dummyScreen() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future privacyPolicy() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future lottiurl() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future quiz() async {
    try {
      return "";
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return "";
    }
  }

  Future FBrewardedAd() async {
    try {
      return '';
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return '';
    }
  }

  Future FBinterstitialAd() async {
    try {
      return '';
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return '';
    }
  }

  Future FBnativeAd() async {
    try {
      return '';
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return '';
    }
  }

  Future FBbannerAd() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future issdkads() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future isEveryads() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future isBackgroudAds() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future showreward() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future colors() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future adManagerIds() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future isfacebookads() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future isnativead() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }

  Future isrecycleAds() async {
    try {
      return true;
    } on PlatformException catch (e) {
      if (kDebugMode) {
        print("Failed to get battery level: '${e.message}'.");
      }
      return true;
    }
  }
}
